<?php
class DsmFacebookEvents{

    public $fb_page_id="82945776796";
    public $limit=100;
    public $month_range=36;
    public $access_token="EAANWvKagZBAMBANVPZCWxWlD90imjnDmpH1B0UZBHNgEv6SjwsZCUv4HPiiKLn8ghTFxLYp4FoaS82qIw25qGWnI37ptxDPzYIjSMVrc0PwNjJvmOKOhFZCQHvpRZCt8J5uoSfnGXonKyQyqtAk536QSlZCElnUZBhy72zDtpomZC4wZDZD";
    public $fields="id,name,description,place,timezone,start_time,cover,ticket_uri,owner,attending_count";
    public $fb_graph_api_version="v3.0";

	public $default_timezone="America/Los_Angeles";
    public $since_date;
    public $until_date;
    public $since_unix_timestamp;
    public $until_unix_timestamp;

    // upcoming or past
    public $show="upcoming";

    public function __construct(){
        // show any kind or errors
        error_reporting(E_ALL);
        ini_set('display_errors', 1);
	}

    public function printContents_DsmFacebookEvents(){

        $dsm_facebook_events=$this;

        $contents="";
        $contents.="<!-- pre-load image loader -->";
        $contents.="<img src='images/ajax-loader.gif' class='display-none' />";

        $contents.="<div class='container'>";
        	$contents.="<div class='row'>";
        		$contents.="<div class='col-md-12'>";

                	ob_start();
                	include_once "navigation_tabs.php";
                	$contents.=ob_get_contents();
                	ob_end_clean();

        			$obj=$dsm_facebook_events->readEvents();

        			if(isset($obj['data'][0])){
        				// show the event list
                        ob_start();
                    	include_once 'items_template.php';
                    	$contents.=ob_get_contents();
                    	ob_end_clean();
        			}

        	        else{
        	            echo "<div class='alert alert-info'>";
        	                echo "No {$dsm_facebook_events->show} events found.";
        	            echo "</div>";
        	        }

        		$contents.="</div> <!-- end col-md-12 -->";
        	$contents.="</div> <!-- end row -->";
        $contents.="</div> <!-- end container -->";

        return $contents;
    }

    // method for the 'head' section of index.php / page where you will put the photo albums
	public function printCSS_DsmFacebookEvents(){

		$css="";

        $css.="<!-- bootstrap css -->";
    	$css.="<link rel='stylesheet' href='libs/js/bootstrap/dist/css/bootstrap.css' media='screen'>";

    	$css.="<!-- font awesome css -->";
    	$css.="<link rel='stylesheet' href='libs/css/font-awesome-4.4.0/css/font-awesome.min.css'>";

    	$css.="<!-- custom css -->";
    	$css.="<link rel='stylesheet' href='libs/css/custom.css'>";

		return $css;
	}

    // method before the closing 'body' tag of index.php / page where you will put the photo albums
	public function printJavaScript_DsmFacebookEvents(){

		$js="";

        $js.="<!-- modal html -->";
        $js.="<div id='events-modal' class='modal'>";
        	$js.="<div class='modal-dialog'>";
        		$js.="<div class='modal-content'>";
        			$js.="<div class='modal-header'>";
        				$js.="<h3 id='event-label' class='modal-title'>Event Date</h3>";
        			$js.="</div>";
        			$js.="<div class='modal-body' style='padding:0;''></div>";
        			$js.="<div class='modal-footer' style='margin:0; padding:8px; border:none; text-align:center;''>";
        				$js.="<button type='button' class='btn btn-default' data-dismiss='modal'>Close</button>";
        			$js.="</div>";
        		$js.="</div><!-- /.modal-content -->";
        	$js.="</div><!-- /.modal-dialog -->";
        $js.="</div><!-- /.modal -->";

        $js.="<!-- jQuery library -->";
        $js.="<script src='libs/js/jquery.js'></script>";

        $js.="<!-- bootstrap JavaScript -->";
        $js.="<script src='libs/js/bootstrap/dist/js/bootstrap.min.js'></script>";
        $js.="<script src='libs/js/bootstrap/docs-assets/js/holder.js'></script>";

        $js.="<!-- HTML5 Shiv and Respond.js IE8 support of HTML5 elements and media queries -->";
        $js.="<!-- WARNING: Respond.js doesn't work if you view the page via file:// -->";
        $js.="<!--[if lt IE 9]>";
        $js.="<script src='https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js'></script>";
        $js.="<script src='https://oss.maxcdn.com/libs/respond.js/1.4.2/respond.min.js'></script>";
        $js.="<![endif]-->";

        $js.="<script src='libs/js/custom.js'></script>";

		return $js;
	}

    public function getPageTitle(){

        $page_title = "";

        if($this->show=="upcoming"){
        	$page_title = "Display UPCOMING Facebook Page Events on Website - LIVE DEMO";
        }

        else if($this->show=="past"){
        	$page_title = "Display PAST Facebook Page Events on Website - LIVE DEMO";
        }

        return $page_title;
    }

    // $show values can be "all", "upcoming", "past" or "fixed"
    // if you set $show = "fixed"; it will use $since_date and $until_date values to fix the date range
    public function setDateRange(){

		date_default_timezone_set($this->default_timezone);

        // automatically adjust date range
        // human readable years

        if($this->show=="upcoming"){
            $this->since_date = date('Y-m-d');
            $this->until_date = date('Y-m-d', strtotime('+' . $this->month_range . ' months'));
        }

        else if($this->show=="past"){
            $this->since_date = date('Y-m-d', strtotime('-' . $this->month_range . ' months'));
            $this->until_date = date('Y-m-d');
        }

        // unix timestamp
        $this->since_unix_timestamp = strtotime($this->since_date);
        $this->until_unix_timestamp = strtotime($this->until_date);
    }

    public function readEvents(){
        $json_link = "https://graph.facebook.com/{$this->fb_graph_api_version}/{$this->fb_page_id}/events/attending/?"
                     . "fields={$this->fields}&access_token={$this->access_token}&"
                     . "since={$this->since_unix_timestamp}&until={$this->until_unix_timestamp}&limit={$this->limit}";

		$json = file_get_contents($json_link);

		$obj = json_decode($json, true, 512, JSON_BIGINT_AS_STRING);

        if($this->show=="upcoming"){
            // this will change the order of events, showing nearest events first
            function sortFunction($a,$b){
            	if ($a['start_time'] == $b['start_time']) return 0;
            	return strtotime($a['start_time']) - strtotime($b['start_time']);
            }
            usort($obj['data'], "sortFunction");
        }

        return $obj;
    }

    public function readOneEvent($event_id){
        // json link
        $json_link = "https://graph.facebook.com/{$this->fb_graph_api_version}/{$event_id}/?fields={$this->fields}&access_token={$this->access_token}";

        $json = file_get_contents($json_link);
        $obj = json_decode($json, true, 512, JSON_BIGINT_AS_STRING);

        return $obj;
    }

    public function auto_link_text($string){
    	$string= preg_replace("#http://([\S]+?)#Uis", '<a href="http://\\1" target="_blank" rel="nofollow">\\1</a>', $string);
    	return $string;
    }

    // draws a calendar
    public function draw_calendar($month,$year,$fb_page_id){

        $this->fb_page_id=$fb_page_id;

    	// get fb events of the month
    	// or you can set a fix date range:
    	$month_last_day = date('t', strtotime("{$year}-{$month}-01"));

    	$since_unix_timestamp = strtotime("{$year}-{$month}-01 00:00:00");
    	$until_unix_timestamp = strtotime("{$year}-{$month}-{$month_last_day} 23:59:59");

    	// json link
    	$json_link = "https://graph.facebook.com/$this->fb_graph_api_version/{$this->fb_page_id}/events/attending/?fields={$this->fields}&access_token={$this->access_token}&since={$since_unix_timestamp}&until={$until_unix_timestamp}";

    	$json = file_get_contents($json_link);
    	$obj = json_decode($json, true, 512, JSON_BIGINT_AS_STRING);

    	$timezone_arr=array();
    	$events_arr = array();
    	$event_count = count($obj['data']);

    	for($x=0; $x<$event_count; $x++){

    		$timezone=isset($obj['data'][$x]['timezone']) ? $obj['data'][$x]['timezone'] : "America/Los_Angeles";
    		date_default_timezone_set($timezone);

    		$start_date = date('Y-m-d', strtotime($obj['data'][$x]['start_time']));
    		array_push($events_arr, $start_date);

    		$tz_index = date('d', strtotime($obj['data'][$x]['start_time']));
    		$timezone_arr[$tz_index]=$timezone;
    	}

    	// draw table
    	$calendar = '<table cellpadding="0" cellspacing="0" class="calendar">';

    		// table headings
    		$headings = array('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
    		$calendar.= '<tr class="calendar-row"><td class="calendar-day-head">'
    				.implode('</td><td class="calendar-day-head">',$headings)
    			.'</td></tr>';

    		// days and weeks vars now ...
    		$running_day = date('w',mktime(0,0,0,$month,1,$year));
    		$days_in_month = date('t',mktime(0,0,0,$month,1,$year));
    		$days_in_this_week = 1;
    		$day_counter = 0;
    		$dates_array = array();

    		// row for week one
    		$calendar.= '<tr class="calendar-row">';

    		// print "blank" days until the first of the current week
    		for($x = 0; $x < $running_day; $x++){
    			$calendar.= '<td class="calendar-day-np"> </td>';
    			$days_in_this_week++;
    		}

    		$timezone_x=0;

    		// keep going with days....
    		for($list_day = 1; $list_day <= $days_in_month; $list_day++){

    			if($list_day<10){
    				$list_day="0" . $list_day;
    			}

    			$date="{$year}-{$month}-{$list_day}";

    			$calendar.= '<td class="calendar-day">';

    				// add in the day number
    				if(in_array($date, $events_arr)){

    					$timezone=$timezone_arr[$list_day];
    					// date_default_timezone_set($timezone);

    					$date_str="Event on " . date("F d, Y", strtotime($date));
    					$link="calendar_content.php?fb_page_id={$this->fb_page_id}&date_selected={$date}&timezone={$timezone}";

    					$calendar.=
    					"<a style='color:#000;' data-toggle='modal' href='{$link}' data-target='#events-modal'
    						data-date='{$date_str}' data-timezone='{$timezone}'>"
    						. "<div class='day-number' style='background-color:#66CCFF; font-weight:bold;'>"
    							. $list_day
    						. "</div>"
    					. "</a>";

    				}else{
    					$calendar.= '<div class="day-number">' . $list_day . '</div>';
    				}

    			$calendar.= '</td>';

    			if($running_day == 6){
    				$calendar.= '</tr>';

    				if(($day_counter+1) != $days_in_month){
    					$calendar.= '<tr class="calendar-row">';
    				}

    				$running_day = -1;
    				$days_in_this_week = 0;
    			}

    			$days_in_this_week++; $running_day++; $day_counter++;
    			$timezone_x++;
    		}

    		// finish the rest of the days in the week
    		if($days_in_this_week < 8){
    			for($x = 1; $x <= (8 - $days_in_this_week); $x++){
    				$calendar.= '<td class="calendar-day-np"> </td>';
    			}
    		}

    		/* final row */
    		$calendar.= '</tr>';

    	// end the table
    	$calendar.= '</table>';

    	// all done, return result
    	return $calendar;
    }
}
?>
